/*
  Name : base.hpp
  Copyright : KPAMEGAN & ROUSSET
  Authors : KPAMEGAN Karel, ROUSSET Baptiste
  Description: file which contents function to use a LCD screen
*/

#ifndef _base_h_
#define _base_h_

class Screen{
public:
  static int counter;                                   //uniq number of the screen
  int fd;                                               //file descriptor of the device

public:
  char line0[20];                                       //line number 0
  char line1[20];                                       //line number 1
  char line2[20];                                       //line number 2
  char line3[20];                                       //line number 3
  char *device;                                         //device of the lcd

public:
  Screen();                                             //this is a constructor
  Screen(char *dev);                                    //this is a constructor
  ~Screen();                                            //this is the destructor
  void open_screen(void);                               //open the device of the screen
  void close_screen(void);                              //close the device of the screen
  int init_home_cursor(void);                           //initialize to the home position
  int set_cursor_line(int nol);                         //set the cursor to the line which is given on argument
  int delete_line(int nol);                             //delete the line passed on argument
  int delete_screen(void);                              //delete the screen
  char *get_line(int nol);                              //return the line which is wanted
  Screen *get_screen(void);                             //return the screen address
  int set_line(int nol, char *newLine);                 //set characters into a line 
  int set_line_center(int nol,char *newLine);           //set characters into the center of a line
  int set_screen(Screen *newScreen);                    //copy a screen
  int show(void);                                       //display the screen
  int go_down(int nb);                                  //put the cursor down
  int go_up(int nb);                                    //put the cursor up
  int go_right(int nb);                                 //put the cursor right
  int go_left(int nb);                                  //put the cursor left
  void set_stars(void);                                 //set stars on the left and on the left of all the screen
  void set_separators(void);                            //set separators between two half-screens
  void clear_area(int xs,int xe,int ys,int ye);         //delete a defined area on the screen
};

#endif
