/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 #ifndef _CONTROLBDD_H_
 #define _CONTROLBDD_H_
 
 #include <string>
 #include <vector>
 #include <iostream>
 #include "sqlite3.h"
#include "libsqlitewrapped.h"
 
  #define BASE "automate" 
 
 using namespace std;
 
 
class ControlBDD {
	
private:
	
	static ControlBDD * instance;
	string dbname;	Database *db;

	ControlBDD(string dbname);

public:
	//ControlBDD(void){}
	
	static ControlBDD* getInstance();
	
/*Getters et Setters*/
	
	string getDbname(void);
	void setDbname(string dbname);
		
	
/*Ouverture de la connexion à la base de donnée MySQL*/
	bool connexionDb(void);

/*Execution d'une requete de type select et qui place les résultats dans un vecteur*/
	vector<string>* selectInDb(string query);
	
/*Fermeture de la connexion à la base de données*/
	void closeConnexionDb(void);
	
	~ControlBDD(void){}
};


#endif
