#ifndef _OSMOLATION_HPP_
#define _OSMOLATION_HPP_

#include <sstream>
#include <iomanip>
#include <string>


#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Osmolation:public Objet
{
private:
  short captor_high;	 // state of the high captor
  short ini;		 // state of osmolation
  short empty_reserv;	// state of the reserv water 1=empty => no osmolation !
  bool stop;		 // used for stopping osmol
  bool reserv_mail;	 //used for sending a mail if there is too much wator
  bool full;		 // used to check if decant is full
  double flow;       // used to count the nb of impulse from flowmeter
  double flowinit;   // used to count the nb of impulse from flowmeter
  bool stopper_osmo;

  time_t rawtime;
  time_t timer;
  time_t reserv_stop;

  void forceState(short,K8055 &,config &);//force the state
  void quantity_est(connexion &, double); //inserting water quantity estimated in bd (osmolation)
  void quantity_flow(connexion &,K8055 &); //inserting water quantity measured with flowmeter in bd (osmolation)
  void changeState (short,K8055 &,config &); //change the state
  void stopper (K8055 &,config&,string);//stop the osmolation

  
  
public:
  Osmolation(){init();}
  void init();

  short getCaptor_high(){return captor_high;}
  short getIni(){return ini;}
  short getEmpty_reserv(){return empty_reserv;}
  bool getStop(){return stop;}
  bool getReserv_mail(){return reserv_mail;}
  bool getFull(){return full;}

  void setCaptor_high(short captor_high){this->captor_high=captor_high;}
  void setIni (short ini){this->ini=ini;}
  void setEmpty_reserv (short empty_reserv){this->empty_reserv=empty_reserv;}
  void setStop(bool stop){this->stop=stop;}
  void setReserv_mail(bool reserv_mail){this->reserv_mail=reserv_mail;}
  void setFull (bool full){this->full=full;}

  
  void changing(connexion &,K8055 &,config &);//define the state witch the lamp had to be

};

#endif

