/*
  Name : main.cpp
  Authors : Salva sébastien
  Description: main file of the automaton
*/

#include "includes/temps.h"
//#include <math.h>
#include <fcntl.h>
//#include <iomanip>
//#include <fstream>
#include <sstream>
#include "includes/automaton.hpp"
#include "includes/param.h"
#include <sys/wait.h>

//#include "includes/configuration.hpp"
//#include "includes/alert.hpp"
//#include "includes/shareData.hpp"
//#include "includes/routine.hpp"
//#include "includes/initTimer.hpp"


//for temperature
double give(double t[20])
{
  int i,j,n,max;
  double v,r=0;
  
  max=0;
  for(i=0;i<20;i++)
    {
      v=t[i];n=0;
      for(j=0;j<20;j++)
	{if (t[j]==v) n++;}
      if (n>=max) {max=n;r=v;}
    }
  return r;
}	





config cfg;

/************SCREEN PARAMETERS*******************/

//extern Alert alert;	     //the alerts screen which comes from routine.cpp
//extern Alert logs;	     //the logs screen which comes from routine.cpp
//pthread_mutex_t mut;	   //variable of exclusion, use in routine.cpp and other.cpp
//shareData dataVal;	   //the structure which contents the aquarium configuration, use in routine.cpp and other.cpp
//InitTimes confTimes(4,3,0); //initialize the time between 2 screens, the number of blinking of ever title and the state of the logs

//*********************************************************
int main(int argc, char** argv)
{
/****************************************/
// used for getting the k8055 config

connexion c(BASE,REP);
short st,sh,day;
bool connected=true; // used with bd connection
bool new_m=false;// used to check new hour
bool pbtemp=false; // used to write one time message alert tempe >40 <20 
double t2,flow=0.0,ph=0.0;
double temperature=25;
bool sup30=false;	//if the temperature is higher than 30°C
bool inf24=false;	//if the temperature is lower than 24°C
double tempe=0;
int i;
stringstream out;
double te[20];
int count=0; // used to compute the temperature from 10 values retains the best one !!!
string s,s2,m;
char q[100];
char ch=0;
sleep(2); // used for restarting (waits the previous automate shuting down)

if (DEBUG==1) cout << BASE << SAVE << PRESENTE << endl;

//******************************************************************
      if(argc > 1)
      {
	if(!strcmp(argv[1],"init-bd") )
	  {
	    c.construct();
	    // database connection
	    c.connect_to_db();
	    insert_error(c,2);
	  }
	}
	else
		{
		connected=c.connect_to_db(); // database connection
		if (connected == false)
			{
			// bd error
			c.construct();
			// database connection
			connected=c.connect_to_db();
			if (connected== false)
				{
				//2d bd error
				c.construct();
				// database connection
				connected=c.connect_to_db();
				if (connected==false) exit(0); //3rd bd error
				else insert_error(c,3);
				}
			else insert_error(c,2);
			}
		}
  fcntl(0,F_SETFL,O_NONBLOCK); //deblocking stdin



// get the config
c.get_config(cfg);
if (DEBUG==1) cout << "config ok" << cfg.FLOWIMPULSE << endl; 

K8055 k(c,cfg,PRESENTE); //card obj
if (DEBUG==1) cout << "k8055 ok" << endl; 


Automaton a(cfg); // automaton obj
if (DEBUG==1) cout << "Automaton ok" << endl; 

if (LASTHOUR==1)
	{
	time(&(a.timer));
	s=ctime(&(a.timer));
	s2=s.substr(s.find(":",0)-2,5);
	if (DEBUG==1) cout << "current time " << s2 << endl;
	if (s2.compare("00:00")==0)
		{
		//bad system time
		// set last hour saved as current time
		s=c.get_lasthour();
		sprintf(q, "date -s %s",s.c_str());
		if (DEBUG==1) cout << "new date with " << q << endl;
		system(q);
		}
	//else ok time initialized by ntp
	}
 c.init_out();

//if (cfg.LCD && cfg.LOGLCD) confTimes.set_state_log(true); else confTimes.set_state_log(false); //if lcd present and if log must be written, configure the lcd screen


//check if log table in BD is not too big
c.maj_log();

if (DEBUG==1) cout << "ph state " << cfg.PH << endl;

  // init start to 0 in database models and indicates the starting of the automaton
  c.set_start();
/********************************************************************/
  /*if (cfg.LCD) // if the lcd screen isn't present, we don't create this thread
  {
    pthread_t th;
    pthread_mutex_init(&mut, NULL);
    if(pthread_create (&th,NULL,lcdRoutine,NULL)<0)  //this is the function used for display the
						    //lcd screen
	  {
			printf("Problem with the thread of the screen\n");
	    exit(0);
	  }
  }*/

/*******************************************************************/

  try {


    if (DEBUG==1) cout << "*** running automate *** \n" << "*** p : print status ***\n"  << "*** q : quit ! ***\n";
send_mail("automate demarre",c);
if (DEBUG==1) cout << "Mail ok" << endl; 
    //init some ouputs
    // for updating k8055
    if (cfg.OUTSKIMMER!=0) a.getSkimmer()->changeState(1,k,cfg);
if (DEBUG==1) cout << "test skimm ok  " << cfg.OUTSKIMMER<< endl; 

    // init counter if used
    if (cfg.FLOW !=0) k.resetcounter(cfg.FLOW,cfg.FLOW_CARD);

     // init correction ph sensor
     if (cfg.PH != 0) a.getphsonde()->set_correction(c.get_calibre());
    // init timer of the rah pump
    if (cfg.OUTRAH!=0) time ( &(a.getRah()->timer));

    // init timer of the hqi
    if (cfg.OUTHQI!=0) time ( &(a.getHqi()->timer));

    while(ch!= 'q' && a.getstart==0)
      {
	if(ch=='p') k.print_status();
	

	//*******************************************************************
	//getting input states
	a.getInputState(k,cfg);
	//*******************************************************************
	// getting analogic input 1 => temperature
        t2= k.readAnalog(INP_TEMP,INP_TEMP_CARD);
	te[count] =(101*t2/256)-23;
	count++;
	if (count==20)
	  {

	//tempe=round(a.getTemperature()->give(te)*100)/100;
	tempe=give(te);
	if((tempe<20 || tempe>40) && (pbtemp==false)) {
	c.insert_log("erreur sonde temperature!!!!! température <20 ou > 40");pbtemp=true;} //error quit
	else temperature=tempe;
	    count=0;
	    /*if(cfg.LCD)
	      {
		pthread_mutex_lock(&mut);
		sprintf(temp,"%g",temperature);
		dataVal.set_temperature(temp);
		pthread_mutex_unlock(&mut);
	      }
	    else {} //ici il faudrait dtruire le thread de la routine de l'cran*/
	  }

	//*******************************************************************
	    // get the forced status of output 0:normal 1:stop forced 2:run forced
	c.get_forced(cfg);

	//*******************************************************************
	// state of hqi changing ?
	if (cfg.OUTHQI!=0)
	{
	  st=a.getHqi()->get_State("hqi",c);
	  a.getHqi()->changing(st,temperature,k,cfg);
	}

	//*******************************************************************
	    // state of blue changing ?
	if (cfg.OUTBLUE!=0)
	{
		st=a.getBlue()->get_State("blue",c);
		a.getBlue()->changing(st,cfg.forced_blue,k,cfg);
	}

	//*******************************************************************
	    // state of blue2 changing ?
	if (cfg.OUTBLUE2!=0)
	{
		st=a.getBlue2()->get_State("blue2",c);
		a.getBlue2()->changing(st,cfg.forced_blue2,k,cfg);
	}

	//******************************************************************
	    //state of pumps
	    //depends of param obj and of input 1 ( physical button)
	if (cfg.OUTPUMP!=0)
	{
		st=a.getPump()->get_State("pump",c);
		/*if(cfg.LCD)
		  {
		    pthread_mutex_lock(&mut);
		    if (a.getPump()->getState()==0)
		      dataVal.set_gdespompes("off");
		    else dataVal.set_gdespompes("on");
		    pthread_mutex_unlock(&mut);
		  }*/
		a.getPump()->changing (st,cfg.forced_pump,k,cfg);

	}
	//*******************************************************************
	    //state of pumps2
	    //depends of param obj and of input 1 ( physical button)
	if (cfg.OUTPUMP2!=0)
	{
		st=a.getPump2()->get_State("pump2",c);
		/*if(cfg.LCD)
		  {
		    pthread_mutex_lock(&mut);
		    if (a.getPump()->getState()==0)
		      dataVal.set_gdespompes("off");
		    else dataVal.set_gdespompes("on");
		    pthread_mutex_unlock(&mut);
		  }*/
		a.getPump2()->changing (st,cfg.forced_pump2,k,cfg);

	}
	//*******************************************************************

	    //enabling / stopping skimmer pump
	    //stopping skimmer if the high captor is enabled
	  if (cfg.OUTSKIMMER!=0)
	    {
		st=a.getSkimmer()->get_State("skimmer",c);
		a.getSkimmer()->changing(st,a.getSkimmer()->getCaptor_high(),k,cfg);
	      /*if(cfg.LCD)
		{
		  pthread_mutex_lock(&mut);
		  if (a.getSkimmer()->getState()==0)
		      dataVal.set_ecumeur("off");
		  else dataVal.set_ecumeur("on");
		  pthread_mutex_unlock(&mut);
		}*/
	    }

	//*******************************************************************
	    //state of osmolations
	  if (cfg.OUTOSMOLATION!=0){

	    a.getOsmolation()->changing(c,k,cfg);

	 /*if(cfg.LCD)
		{
		  pthread_mutex_lock(&mut);
		  if (a.getOsmolation()->getState()==0)
		    dataVal.set_osmolation("off");
		  else dataVal.set_osmolation("on");
		 if(a.getOsmolation()->getEmpty_reserv()==0)
		  dataVal.set_reserve("ok");
		    else dataVal.set_reserve("vide");

		pthread_mutex_unlock(&mut);
		}*/
  }
	//*******************************************************************
       //state of pump remont
	  if (cfg.OUTPREMONT!=0)
		{
		a.getPremont()->changing(k,cfg);
		}

	
	//*******************************************************************
       //state of ventilator
	  if (cfg.OUTVENT!=0)
		{
		a.getVentilator()->changing(temperature,k,cfg);
		}

	//*******************************************************************
	    //temperature state
	    // maj current temperature
	c.insert_current_temperature(temperature);
	//if the temp is higher than 29°C for the first time  
	  if (temperature > 29.0 && sup30==false)
	    {
      		send_mail("temperature > 29 !!!!!",c);
      		sup30=true;
    	    }
	//remove the flag of sup30
	if (temperature <= 28.0 && sup30==true)
	sup30=false;
	
  	//if the temp is lower than 22°C for the first time  
  	if (temperature < 22.0 && inf24==false)
    	{
      	send_mail("temperature < 22 !!! pb avec chauffage",c);
      	inf24=true;
    	}
	//remove the flag of inf24  
  	if (temperature >= 22) inf24=false;
	
	if (cfg.OUTTEMP!=0)
	{
		a.getTemperature()->tempState(c,temperature,k,cfg);
		/*if(cfg.LCD)
		{
		  pthread_mutex_lock(&mut);
		  if (a.getTemperature()->getState()==0)
		    dataVal.set_chauffage("off");
		  else dataVal.set_chauffage("on");
		  pthread_mutex_unlock(&mut);
		}*/
	}
	//*******************************************************************
	          //ph state
		  // maj current ph
		 if (cfg.PH != 0) {
		 ph=a.getphsonde()->read_ph(c);
		 //if (DEBUG==1) cout << ph << endl;
		  }
       
      //*******************************************************************
    // some operations depending on time
	time (&(a.timer));
	s=ctime(&(a.timer));
	s2=s.substr(s.find(":",0)+1,2);
	st=atoi(s2.c_str()); // minute
	s2=s.substr(s.find(":",0)-2,2);
	sh=atoi(s2.c_str()); //hour

	if (st==0 && new_m==false)
	  {
	    new_m=true;
	    if (LASTHOUR ==1) c.set_lasthour(s.substr(s.find(":",0)-2,8));
	    waitpid(-1,NULL,0);
	    if (cfg.FLOWTYPE==1) //if flowmeter used without the osmolation module
		{
		if (DEBUG==1) cout << "flow " << flow << endl;
		flow=(double)k.readcounter(cfg.FLOW,cfg.FLOW_CARD);
		c.insert_osmolation((flow)/cfg.FLOWIMPULSE);
		k.resetcounter(cfg.FLOW,cfg.FLOW_CARD);
		if (DEBUG==1) cout << "flow " << flow << endl;
		}
		if (sh==0)
	      {
		//new day !!!
		if (cfg.OUTHQI!=0) a.getHqi()->setStop(false); // re-enable HQI
		c.maj_log(); // delete logs 1 week is saved
		c.maj_water(); // new day water top off updated to 0
		m=s.substr(8,2);
		day=atoi(m.c_str());
		/*if(day==1) {
			c.maj_temperature();  // new month => min and max temp deleted in temperature table
			c.maj_ph(); // new month => min and max temp deleted in ph table
			     }*/
	      }

	    c.insert_temperature(temperature);
	    if (cfg.PH != 0)		    
		{if (a.getphsonde()->get_error()==false) c.insert_ph(ph);}
	    c.save(); // save current bd every hour
	  }
	if (st==1 && new_m==true)
	  new_m=false;

	//*******************************************************************
	    // rah pump state
	if (cfg.OUTRAH!=0)
	{
		st=a.getRah()->get_State("rah",c);
		/*if(cfg.LCD)
		  {
		    pthread_mutex_lock(&mut);
		    if (a.getRah()->getState()==0)
		      dataVal.set_rah("off");
		    else dataVal.set_rah("on");
		    pthread_mutex_unlock(&mut);
		  }*/
		a.getRah()->changing(st,c,k,cfg);
	}
	//*******************************************************************
	// state of peristatic pumps
	for(i=0;i<4;i++)
		{	
		if (cfg.OUTPERI[i]!=0)
			{
			out.str("");			
			out << (i+1);							
			st=a.getPeristatic(i)->get_State("pdoseuse"+out.str(),c);		
			a.getPeristatic(i)->changing(st,k,cfg);			
			}
		 /*if(cfg.LCD)
		   {
		     pthread_mutex_lock(&mut);
		     if (a.getPeristatic()->getState()==0)
			dataVal.set_pompes("off");
		     else dataVal.set_pompes("on");
		     pthread_mutex_unlock(&mut);
		   }*/
		 
	}
	//*******************************************************************
	ch=0;
	read(0, &ch, 1);
	k.maj();
	sleep(1);
	//*******************************************************************
	// checking if the automaton must be restarted
	a.getstart=c.get_start();
	a.restart(c);
      }//endwhile

    c.set_stop();
    c.close();

  }
  catch (exception& er) {
    // handle any connection or query errors that may come up
    cout << "Error: sqlite";
    return -1;//exit(0);
  }

return 0;
}

