#include "stdafx.h"
#include "cphidgetadvancedservo.h"
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"

CSENDPACKET_BUF(AdvancedServo, outputPacket, outputPacketLen)
CMAKEPACKET_BUF(AdvancedServo, outputPacket, outputPacketLen)

int PAS_set_motor(CPhidgetAdvancedServoInfo *phid, int Index)
{
	unsigned char buffer[20];
	int pwm, velocity, accel;
	buffer[0] = 0;

	if (!CPhidget_isAttached(&phid->phid)) return EPHIDGET_NOTATTACHED;

	if ((phid->phid.deviceVersion >= 100) && (phid->phid.deviceVersion < 200))
	{
		pwm = (int)((phid->motorPWMDesired[Index] * 128.0) + 2944);
		velocity = (int)(phid->motorMaxVelocity[Index] * 40.95);
		accel = (int)(phid->motorAcceleration[Index] * 2.55);
		buffer[0] = (unsigned char)Index;
		buffer[1] = (unsigned char)((pwm >> 8) & 0xff);
		buffer[2] = (unsigned char)(pwm & 0xff);
		buffer[3] = (unsigned char)((velocity >> 8) & 0x0f);
		buffer[4] = (unsigned char)(velocity & 0xff);
		buffer[5] = (unsigned char)(accel);
		return _sendpacket(phid, buffer, 6);
	}
	return EPHIDGET_UNEXPECTED;
}

CFHANDLE(AdvancedServo,Position) int, double), void *userPtr)
ASGNFPTR(AdvancedServo,Position)

CPHIDGETDATA(AdvancedServo)
	int i,j;
	TESTPTR(phid)


	for (i = 0; i<phid->phid.attr.advancedservo.numMotors; i++)
	{
		j = (char)buffer[4 + i];
		j = (j * 100) / 127;
		if (phid->motorPWMCurrent[i] != j)
		{
			phid->motorPWMCurrent[i] = j;
			FIRE(Position) i, j);
		}
	}
	return EPHIDGET_OK;
}

CGET(AdvancedServo,NumMotors,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.advancedservo.numMotors)
}

CGETINDEX(AdvancedServo,MotorPosition,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.advancedservo.numMotors)
	//abort();
	return EPHIDGET_OK;
	MASGN1(motorAcceleration[Index])
}
CSETINDEX(AdvancedServo,MotorPosition,double)
	int result = EPHIDGET_OK;
	TESTPTR(phid) 
	TESTRNG1(phid.attr.advancedservo.numMotors)
	if ((newVal > 250) || (newVal < -23)) return EPHIDGET_INVALIDARG;
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Position, "%lf")
	else
	{
		phid->motorPWMDesired[Index] = (char)newVal;
		result = PAS_set_motor(phid, Index);
	}
	return result;
}

CGETINDEX(AdvancedServo,Acceleration,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.advancedservo.numMotors)
	MASGN1(motorAcceleration[Index])
}
CSETINDEX(AdvancedServo,Acceleration,double)
	int result = EPHIDGET_OK;
	TESTPTR(phid) 
	TESTRNG1(phid.attr.advancedservo.numMotors)
	if ((newVal > 100) || (newVal < 0)) return EPHIDGET_INVALIDARG;
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Acceleration, "%lf")
	else
	{
		phid->motorAcceleration[Index] = newVal;
		result = PAS_set_motor(phid, Index);
	}
	return result;
}
CGETINDEX(AdvancedServo,MaxVelocity,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.advancedservo.numMotors)
	MASGN(motorPWMCurrent[Index]);
}

CSETINDEX(AdvancedServo,MaxVelocity,double)
	int result = EPHIDGET_OK;
	TESTPTR(phid) 
	TESTRNG1(phid.attr.advancedservo.numMotors)
	if ((newVal > 100) || (newVal < -100)) return EPHIDGET_INVALIDARG;	
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Velocity, "%lf")
	else
	{
		phid->motorMaxVelocity[Index] = newVal;
		result = PAS_set_motor(phid, Index);
	}
	return result;
}

CGETINDEX(AdvancedServo,Current,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.advancedservo.numMotors)
	MASGN(motorSensedCurrent[Index]);
}

CPHIDGETINIT(AdvancedServo)
	int i;
	for (i = 0; i<phid->phid.attr.advancedservo.numMotors; i++)
		phid->motorAcceleration[i] = 10;
	return EPHIDGET_OK;
}

CCREATE(AdvancedServo, PHIDDEF_ADVANCEDSERVO)

