#ifndef CCONSTANTS
#define CCONSTANTS

/* states for the status variable */
#define PHIDGET_ATTACHED	0x1
#define PHIDGET_NOTATTACHED	0x0
#define PHIDGET_CONNECTIONERROR	0x2

#define	PHIDGET_ERROR_CODE_COUNT				17
#define EPHIDGET_OK				0
#define EPHIDGET_NOTFOUND			1	
#define EPHIDGET_NOMEMORY			2
#define EPHIDGET_UNEXPECTED			3
#define EPHIDGET_INVALIDARG			4
#define EPHIDGET_NOTATTACHED			5
#define EPHIDGET_INTERRUPTED			6
#define EPHIDGET_INVALID			7
#define EPHIDGET_NETWORK			8
#define EPHIDGET_UNKNOWNVAL			9
#define EPHIDGET_BADPASSWORD			10
#define EPHIDGET_UNSUPPORTED			11
#define EPHIDGET_DUPLICATE			12
#define EPHIDGET_TIMEOUT			13
#define EPHIDGET_OUTOFBOUNDS			14
#define EPHIDGET_EVENT			15
#define EPHIDGET_NETWORK_NOTCONNECTED			16

#define PFALSE	0x00
#define PTRUE	0x01
#define PUNK	0x02

#define MAXDEVICETYPELENGTH 50

#define PHIDGET_DEVICE_TYPE_COUNT 23

#define PHIDDEF_NOTHING_00		0x00 
#define PHIDDEF_NOTHING_01		0x01 
#define PHIDDEF_NOTHING_02		0x02 
#define PHIDDEF_INTERFACEKIT		0x03 
#define PHIDDEF_SERVO			0x04
#define PHIDDEF_HUMIDITYSENSOR		0x05
#define PHIDDEF_NOTHING_06		0x06
#define PHIDDEF_RFID			0x07
#define PHIDDEF_WEIGHTSENSOR		0x08
#define PHIDDEF_NOTHING_09		0x09
#define PHIDDEF_TEXTLCD			0x0A
#define PHIDDEF_MOTORCONTROL		0x0B
#define PHIDDEF_NOTHING_0C		0x0C
#define PHIDDEF_LED			0x0D
#define PHIDDEF_ENCODER			0x0E
#define PHIDDEF_STEPPER			0x0F
#define PHIDDEF_TEMPERATURESENSOR	0x10
#define PHIDDEF_ACCELEROMETER		0x11
#define PHIDDEF_TEXTLED			0x12
#define PHIDDEF_PHSENSOR		0x13
#define PHIDDEF_GYROSCOPE		0x14
#define PHIDDEF_ADVANCEDSERVO		0x15
#define PHIDDEF_GPS			0x16

#define PHIDGET_DEVICE_COUNT 43

#define PHIDSPEC_NOTHING			0x00
#define PHIDSPEC_SERVO_1MOTOR			0x01
#define PHIDSPEC_INTERFACEKIT_8_8_8		0x02
#define PHIDSPEC_INTERFACEKIT_0_0_4		0x03
#define PHIDSPEC_INTERFACEKIT_0_16_16		0x04
#define PHIDSPEC_INTERFACEKIT_0_5_7		0x05
#define PHIDSPEC_INTERFACEKIT_0_8_8		0x06
#define PHIDSPEC_ACCELEROMETER			0x07
#define PHIDSPEC_TEXTLCD_2_20			0x08
#define PHIDSPEC_TEXTLCD_2_20_CUSTOM		0x09
#define PHIDSPEC_TEXTLCD_2_20_COMP1		0x0A
#define PHIDSPEC_RFID				0x0B
#define PHIDSPEC_LED				0x0C
#define PHIDSPEC_TEXTLED			0x0D
#define PHIDSPEC_MOTORCONTROL			0x0E
#define PHIDSPEC_TEMPERATURESENSOR		0x0F
#define PHIDSPEC_STEPPER			0x10
#define PHIDSPEC_ENCODER			0x11

#define PHIDSPEC_INTERFACEKIT_4_8_8		0x12
#define PHIDSPEC_SERVO_4MOTOR_OLD		0x13
#define PHIDSPEC_SERVO_1MOTOR_OLD		0x14
#define PHIDSPEC_WEIGHTSENSOR			0x15
#define PHIDSPEC_HUMIDITYSENSOR			0x16
#define PHIDSPEC_PHSENSOR			0x17
#define PHIDSPEC_GYROSCOPE			0x18
#define PHIDSPEC_ADVANCEDSERVO8			0x19
#define PHIDSPEC_RFIDB				0x1A
#define PHIDSPEC_TEXTLED2			0x1B

#define PHIDSPEC_LINEAR_TOUCH			0x1C
#define PHIDSPEC_ROTARY_TOUCH			0x1D
#define PHIDSPEC_ENCODER_4			0x1E

#define PHIDSPEC_GPS				0x1F
#define PHIDSPEC_ENCODER_HS			0x20
#define PHIDSPEC_UNIPOLAR_STEPPER		0x21
#define PHIDSPEC_BIPOLAR_STEPPER		0x22
#define PHIDSPEC_JOYSTICK			0x23
#define PHIDSPEC_TEXTLCD_with_888		0x24
#define PHIDSPEC_888_with_lcd			0x25
#define PHIDSPEC_ACCELEROMETER3			0x26
#define PHIDSPEC_ACCELEROMETER_with_GYRO	0x27
#define PHIDSPEC_GYRO_with_ACCELEROMETER	0x28
#define PHIDSPEC_SERVO_4MOTOR			0x29
#define PHIDSPEC_MOTORCONTROL_HC			0x2A


extern const char LibraryVersion[];
extern const char *Phid_DeviceName[PHIDGET_DEVICE_TYPE_COUNT];
extern const char *Phid_DeviceSpecificName[PHIDGET_DEVICE_COUNT];
extern const char Phid_Device_Def_WorkAroundA[PHIDGET_DEVICE_COUNT][2];
extern const char Phid_UnknownErrorDescription[];
extern const char *Phid_ErrorDescriptions[PHIDGET_ERROR_CODE_COUNT];

#endif

