#include "stdafx.h"
#include "cphidgetencoder.h"
#include <stdio.h>
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"

CMAKEPACKET_BUF(Encoder, outputPacket, outputPacketLen)

CFHANDLE(Encoder,Input) int, int), void *userPtr)
ASGNFPTR(Encoder,Input)

CFHANDLE(Encoder,Position) int, int, int), void *userPtr)
ASGNFPTR(Encoder,Position)

CPHIDGETDATA(Encoder)
	unsigned short encoder_sel;
	unsigned short time,tempC;
	short incr;
	int i=0,j=0;

	TESTPTR(phid)

	/* OLD version here... */
	if (phid->phid.deviceVersion < 110) {
		encoder_sel = 0;

		if (phid->physicalState[0])
		{
			if ((buffer[1] & 0x04) != 0)
			{
				phid->physicalState[0] = PFALSE;
				if (phid->fptrInputChange)
					phid->fptrInputChange(phid, phid->fptrInputChangeptr, encoder_sel, PFALSE);
			}
		}
		else if ((buffer[1] & 0x04) == 0)
		{
			phid->physicalState[0] = PTRUE;
			if (phid->fptrInputChange)
				phid->fptrInputChange(phid, phid->fptrInputChangeptr, encoder_sel, PTRUE);
		}	
		if (buffer[2] != 0)
		{
			phid->encoderPosition[encoder_sel]+= (char)buffer[2];
			time = (((unsigned short)buffer[4]) << 8) + buffer[3];
			tempC = (time - phid->encoderTimeStamp[encoder_sel]);

			if (tempC > 30000) tempC = 30000;
			//printf("%d : %d ", time, phid->encoderTimeStamp[encoder_sel]);
			phid->encoderTimeStamp[encoder_sel] = time;

			if (phid->fptrPositionChange)
				phid->fptrPositionChange(phid, phid->fptrPositionChangeptr, encoder_sel, (unsigned short)tempC, (char)buffer[2]);
		}
	}
	
	/* NEW version 1-encoder = 1.10+, 4-encoder = 2.00+ */
	else if (phid->phid.deviceVersion >= 110 && phid->phid.deviceVersion < 300) {
		for (i = 0, j = 1; i<(phid->phid.attr.encoder.numInputs); i++, j=j<<1)
		{
			if (buffer[1] & j)
			{
				if (phid->physicalState[i] != PFALSE)
				{
					phid->physicalState[i] = PFALSE;
					FIRE(Input) i, PFALSE);
				}
			}
			else
			{
				if (phid->physicalState[i] != PTRUE)
				{
					phid->physicalState[i] = PTRUE;
					FIRE(Input) i, PTRUE);
				}
			}
		}
		
		time = (((unsigned short)buffer[3]) << 8) + buffer[2];
		
		for(i=0;i<phid->phid.attr.encoder.numEncoders;i++) {
			if (buffer[i+4] != 0)
			{
				phid->encoderPosition[i]+= (char)buffer[i+4];
				tempC = (time - phid->encoderTimeStamp[i]);

				if (tempC > 30000) tempC = 30000;
				phid->encoderTimeStamp[i] = time;

				if (phid->fptrPositionChange)
					phid->fptrPositionChange(phid, phid->fptrPositionChangeptr, i, (unsigned short)tempC, (char)buffer[i+4]);
			}
		}
	}
		
	/* high speed encoder */
	else if (phid->phid.deviceVersion >= 300 && phid->phid.deviceVersion < 400) {

		for (i = 0, j = 1; i<(phid->phid.attr.encoder.numInputs); i++, j=j<<1)
		{
			if (buffer[1] & j)
			{
				if (phid->physicalState[i] != PFALSE)
				{
					phid->physicalState[i] = PFALSE;
					FIRE(Input) i, PFALSE);
				}
			}
			else
			{
				if (phid->physicalState[i] != PTRUE)
				{
					phid->physicalState[i] = PTRUE;
					FIRE(Input) i, PTRUE);
				}
			}
		}
		
		time = (((unsigned short)buffer[3]) << 8) + buffer[2];

		for(i=0;i<phid->phid.attr.encoder.numEncoders;i++) {
			incr = (((unsigned short)buffer[2*i+5]) << 8) + buffer[2*i+4];
			if (incr != 0)
			{
				//printf("data %02x %02x  %d\n",buffer[2*i+5],buffer[2*i+4],incr);
				//phid->encoderPosition[i]=incr;
				phid->encoderPosition[i]+= incr;
				tempC = (time - phid->encoderTimeStamp[i]);

				if (tempC > 30000) tempC = 30000;
				phid->encoderTimeStamp[i] = time;

				if (phid->fptrPositionChange)
					phid->fptrPositionChange(phid, phid->fptrPositionChangeptr, i, (unsigned short)tempC, incr);
			}
		}
	}
	return EPHIDGET_OK;
}

CGETINDEX(Encoder,EncoderPosition,int)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.encoder.numEncoders)
	MASGN(encoderPosition[Index])
}

CSETINDEX(Encoder,EncoderPosition,int)
	TESTPTR(phid) 
	TESTRNG1(phid.attr.encoder.numEncoders)
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(ResetPosition, "%d")
	else
		phid->encoderPosition[Index] = newVal;
	return EPHIDGET_OK;
}

CGET(Encoder,NumInputs,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.encoder.numInputs)
}

CGET(Encoder,NumEncoders,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.encoder.numEncoders)
}

CGETINDEX(Encoder,InputState,int)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.encoder.numInputs)
	MASGN1(physicalState[Index])
}

CPHIDGETINIT(Encoder)
	phid = 0;
	return EPHIDGET_OK;
}

CCREATE(Encoder, PHIDDEF_ENCODER)
