#include "stdafx.h"
#include "cphidgettextlcd.h"
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"

CSENDPACKET_BUF(TextLCD, outputPacket, outputPacketLen)
CMAKEPACKET_BUF(TextLCD, outputPacket, outputPacketLen)

int set_status(CPhidgetTextLCDInfo *phid)
{
	unsigned char buffer[20];
	buffer[0] = 0;
	TESTPTR(phid)
	if 	(CPhidget_isAttached(&phid->phid) && ((phid->phid.ProductID == 0x51) || (phid->phid.ProductID == 0x52) || (phid->phid.ProductID == 0x53) || (phid->phid.ProductID == 0x7D)))
	{
		buffer[0] = 0x0C;
		if (phid->m_blnCursorOn) buffer[0] |= 0x02;
		if (phid->m_blnCursorBlink) buffer[0] |= 0x01;		
		buffer[7] = 0x01;
		return _sendpacket(phid, buffer, 8);
	}
	return EPHIDGET_UNEXPECTED;
}

PHIDGET21_API int CCONV CPhidgetTextLCD_setDisplayString(CPhidgetTextLCDHandle phid, int Row, char *displayString)
{
	
	int i,j, buf_ptr,result=EPHIDGET_OK;
	unsigned int ui;
	size_t len;
	unsigned char form_buffer[50];
	unsigned char buffer[10];
	char *newVal = displayString;
	int Index = Row;

	TESTPTR(phid)
		
	if (Row >= phid->phid.attr.textlcd.numRows) return EPHIDGET_INVALIDARG;
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(DisplayString, "%s")
	else
	{
		len = strlen(displayString);
		if 	((phid->phid.ProductID == 0x51) || (phid->phid.ProductID == 0x52) || (phid->phid.ProductID == 0x53) || (phid->phid.ProductID == 0x7D))
		{
			if (len > 20) len = 20;
		
			form_buffer[0] = 0x01; /* Command */
			form_buffer[1] = ((unsigned char)Row) * 0x40 + 0x80; /* Address */
			form_buffer[2] = 0x02;
			buf_ptr = 3;
			for (ui = 0; ui<len; ui++)
			{
				if ((displayString[ui] == 0x01) || (displayString[ui] == 0x02))
					form_buffer[buf_ptr++] = 0x00;
				form_buffer[buf_ptr++] = displayString[ui];
			}
			for (ui = 0; ui < (20 - len); ui++)
			{
				form_buffer[buf_ptr++] = 0x20;
			}
			form_buffer[buf_ptr++] = 0x01; 
			form_buffer[buf_ptr++] = ((unsigned char)Row) * 0x40 + 0x80 + (unsigned char)strlen(displayString);  

			CThread_mutex_lock(&phid->phid.writelock);

			for (i = 0; i<buf_ptr; i+=7)
			{
				for (j = 0; j<8; j++)
					buffer[j] = 0;
				if ((buf_ptr - i) > 7) len = 7;
				else len = (buf_ptr - i);
				for (ui = 0; ui < len; ui++)
					buffer[ui] = form_buffer[i + ui];
				buffer[7] = (unsigned char)len;
				
				if ((result = _sendpacket(phid, buffer, 8)) !=
					EPHIDGET_OK)
				{
					CThread_mutex_unlock(&phid->phid.writelock);
					return result;
				}
			}
			
			CThread_mutex_unlock(&phid->phid.writelock);

			return result;

		}
		return EPHIDGET_UNEXPECTED;	
	}
	return EPHIDGET_OK;
}
	

CGET(TextLCD,NumRows,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.textlcd.numRows)
}
CGET(TextLCD,NumColumns,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.textlcd.numColumns)
}
CGET(TextLCD,Backlight,int)
	TESTPTRS(phid,pVal) 
	MASGN(m_blnBacklight)
}

CSET(TextLCD,Backlight,int)
	int ret;
	unsigned char buffer[10];
	TESTPTR(phid) 
	if(phid->phid.networkInfo)
		ADDNETWORKKEY(Backlight, "%d")
	else
	{
		CThread_mutex_lock(&phid->phid.writelock);
		phid->m_blnBacklight = (unsigned char)newVal;

		if ((phid->phid.ProductID == 0x51) | (phid->phid.ProductID == 0x52) | (phid->phid.ProductID == 0x53) || (phid->phid.ProductID == 0x7D))
		{
			buffer[0] = 0x00;
			if (newVal) buffer[0] = 0x01;
			buffer[7] = 0x11;
			ret = _sendpacket(phid, buffer, 8);
			CThread_mutex_unlock(&phid->phid.writelock);
			return ret;
		}
		CThread_mutex_unlock(&phid->phid.writelock);
		return EPHIDGET_UNEXPECTED;
	}
	return EPHIDGET_OK;
}
CGET(TextLCD,CursorOn,int)
	TESTPTRS(phid,pVal) 
	MASGN(m_blnCursorOn)
}

CSET(TextLCD,CursorOn,int)
	int ret;
	TESTPTR(phid) 
	if(phid->phid.networkInfo)
		ADDNETWORKKEY(CursorOn, "%d")
	else
	{
		CThread_mutex_lock(&phid->phid.writelock);
		phid->m_blnCursorOn = (unsigned char)newVal;
		ret = set_status(phid);
		CThread_mutex_unlock(&phid->phid.writelock);
		return ret;
	}
	return EPHIDGET_OK;
}
CGET(TextLCD,CursorBlink,int)
	TESTPTRS(phid,pVal) 
	MASGN(m_blnCursorBlink)
}
CGET(TextLCD,Contrast,int)
	TESTPTRS(phid,pVal) 
	MASGN(m_iContrast)
}
CSET(TextLCD,CursorBlink,int)
	int ret;
	TESTPTR(phid) 
	if(phid->phid.networkInfo)
		ADDNETWORKKEY(CursorBlink, "%d")
	else
	{
		CThread_mutex_lock(&phid->phid.writelock);
		phid->m_blnCursorBlink = (unsigned char)newVal;
		ret = set_status(phid);
		CThread_mutex_unlock(&phid->phid.writelock);
		return ret;
	}
	return EPHIDGET_OK;
}

CSET(TextLCD,Contrast,int)
	int ret;
	unsigned char buffer[10];
	if ((newVal < 0) || (newVal > 255)) return EPHIDGET_INVALIDARG;
	if(phid->phid.networkInfo)
		ADDNETWORKKEY(Contrast, "%d")
	else
	{
		CThread_mutex_lock(&phid->phid.writelock);
		phid->m_iContrast = (unsigned char)newVal;

		if ((phid->phid.ProductID == 0x51) | (phid->phid.ProductID == 0x52) | (phid->phid.ProductID == 0x53) | (phid->phid.ProductID == 0x7D))
		{
			buffer[0] = newVal;
			buffer[7] = 0x12;
			ret = _sendpacket(phid, buffer, 8);
			CThread_mutex_unlock(&phid->phid.writelock);
			return ret;
		}
		CThread_mutex_unlock(&phid->phid.writelock);
		return EPHIDGET_UNEXPECTED;
	}
	return EPHIDGET_OK;
}


PHIDGET21_API int CCONV CPhidgetTextLCD_setCustomCharacter (CPhidgetTextLCDHandle phid, int Index, int Val1, int Val2)
{
	unsigned char buffer[10];
	int ret;
	char newVal[50];
	TESTPTR(phid)
	if ((Index < 8) || (Index > 15)) return EPHIDGET_INVALIDARG;
	if(phid->phid.networkInfo)
	{
		sprintf(newVal, "%d,%d", Val1, Val2);
		ADDNETWORKKEYINDEXED(CustomCharacter, "%s")
	}
	else
	{
		if ((phid->phid.ProductID == 0x51) | (phid->phid.ProductID == 0x52) | (phid->phid.ProductID == 0x53) | (phid->phid.ProductID == 0x7D))
		{
			buffer[0] = 0x01;
			buffer[1] = Index * 8;
			buffer[2] = 0x02;
			buffer[3] = (Val1 & 0x1F) | 0x80;
			buffer[4] = ((Val1 >> 5) & 0x1F) | 0x80;
			buffer[5] = ((Val1 >> 10) & 0x1F) | 0x80;
			buffer[6] = ((Val1 >> 15) & 0x1F) | 0x80;
			buffer[7] = 0x07;

			CThread_mutex_lock(&phid->phid.writelock);
			if ((ret = _sendpacket(phid, buffer, 8)) != EPHIDGET_OK)
			{
				CThread_mutex_unlock(&phid->phid.writelock);
				return ret;
			}

			buffer[0] = (Val2 & 0x1F) | 0x80;
			buffer[1] = ((Val2 >> 5) & 0x1F) | 0x80;
			buffer[2] = ((Val2 >> 10) & 0x1F) | 0x80;
			buffer[3] = ((Val2 >> 15) & 0x1F) | 0x80;
			buffer[4] = 0x01;
			buffer[5] = 0;
			buffer[6] = 0;
			buffer[7] = 0x05;

			ret = _sendpacket(phid, buffer, 8);
			CThread_mutex_unlock(&phid->phid.writelock);
			return ret;
		}
		
		else return EPHIDGET_UNEXPECTED;
	}
	return EPHIDGET_OK;

}

CPHIDGETDATA(TextLCD)
	phid = 0;
	return EPHIDGET_OK;
}

CPHIDGETINIT(TextLCD)
	phid->m_blnBacklight = (unsigned char)1;
	return EPHIDGET_OK;
}

CCREATE(TextLCD, PHIDDEF_TEXTLCD)
