#ifndef __CSOCKET
#define __CSOCKET

#include "cphidget.h"
#include "cphidgetmanager.h"
#include "cphidgetdictionary.h"

#ifndef EXTERNALPROTO

extern CThread_mutex_t serverLock;

void internal_async_network_error_handler(const char *error, void *phid);
int unregisterRemotePhidget(CPhidgetHandle phid);
int unregisterRemoteDictionary(CPhidgetDictionaryHandle dict);
int unregisterRemoteManager(CPhidgetManagerHandle phidm);
int CPhidgetSocketClient_isAttached(CPhidgetSocketClientHandle socket);
void CPhidgetSocketClient_setStatus(CPhidgetSocketClientHandle socket, int v);

PHIDGET21_API void CCONV CPhidgetSocketClient_free(void *arg);
PHIDGET21_API int CCONV CPhidgetSocketClient_areEqual(void *arg1, void *arg2);
PHIDGET21_API int CCONV CPhidgetSocketClient_create(CPhidgetSocketClientHandle *arg);

#endif

PHIDGET21_API int CCONV CPhidget_openRemote(CPhidgetHandle phid,
    int serial, const char *serverID, const char *passWord);
PHIDGET21_API int CCONV CPhidget_openRemoteIP(CPhidgetHandle phid,
    int serial, const char *addr, int port, const char *passWord);
PHIDGET21_API int CCONV CPhidgetManager_openRemoteIP(CPhidgetManagerHandle phidm, 
	const char *address, int port, const char *password);
PHIDGET21_API int CCONV CPhidgetManager_openRemote(CPhidgetManagerHandle phidm, 
	const char *serverID, const char *passWord);
PHIDGET21_API int CCONV CPhidgetDictionary_openRemoteIP(CPhidgetDictionaryHandle dict, 
	const char *address, int port, const char *password);
PHIDGET21_API int CCONV CPhidgetDictionary_openRemote(CPhidgetDictionaryHandle dict, 
	const char *serverID, const char *passWord);

#endif
