#ifndef PHIDGET_H
#define PHIDGET_H
#ifdef __cplusplus
extern "C" {
#endif





typedef struct _CPhidget CPhidget, *CPhidgetHandle;
 int CPhidget_open(CPhidgetHandle phid, int serialNumber);
 int CPhidget_close(CPhidgetHandle phid);
 int CPhidget_delete(CPhidgetHandle phid);
 int CPhidget_set_OnDetach_Handler(CPhidgetHandle,
    int( *fptr)(CPhidgetHandle, void *), void *userPtr);
 int CPhidget_set_OnAttach_Handler(CPhidgetHandle, int( *fptr)(CPhidgetHandle, void *), void *userPtr);
 int CPhidget_set_OnError_Handler(CPhidgetHandle phid, int( *fptr)(CPhidgetHandle, void *, int, const char *), void *userPtr);
 int CPhidget_getDeviceName(CPhidgetHandle phid,
    const char **buffer);
 int CPhidget_getSerialNumber(CPhidgetHandle phid,
    int *serialNumber);
 int CPhidget_getDeviceVersion(CPhidgetHandle phid,
    int *devVer);
 int CPhidget_getDeviceStatus(CPhidgetHandle phid,
    int *status);
 int CPhidget_getLibraryVersion(const char **buffer);
 int CPhidget_getDeviceType(CPhidgetHandle phid,
    const char **buffer);
 int CPhidget_getDeviceLabel(CPhidgetHandle phid, const char **buffer);
 int CPhidget_setDeviceLabel(CPhidgetHandle phid, const char *buffer);
 int CPhidget_getErrorDescription(int ErrorCode, const char **buf);
 int CPhidget_waitForAttachment(CPhidgetHandle phid, int milliseconds);
 int CPhidget_getServerID(CPhidgetHandle phid, const char **serverID);
 int CPhidget_getServerAddress(CPhidgetHandle phid, const char **address, int *port);
 int CPhidget_getServerStatus(CPhidgetHandle phid, int *status);
typedef enum {
 PHIDGET_DICTIONARY_VALUE_CHANGED = 1,
 PHIDGET_DICTIONARY_ENTRY_ADDED,
 PHIDGET_DICTIONARY_ENTRY_REMOVING,
 PHIDGET_DICTIONARY_CURRENT_VALUE
} CPhidgetDictionary_keyChangeReason;
typedef struct _CPhidgetDictionary __CPhidgetDictionary; typedef __CPhidgetDictionary *CPhidgetDictionaryHandle;
typedef struct _CPhidgetDictionaryListener __CPhidgetDictionaryListener; typedef __CPhidgetDictionaryListener *CPhidgetDictionaryListenerHandle;
 int CPhidgetDictionary_create(CPhidgetDictionaryHandle *dict);
 int CPhidgetDictionary_close(CPhidgetDictionaryHandle dict);
 int CPhidgetDictionary_delete(CPhidgetDictionaryHandle dict);
 int CPhidgetDictionary_set_OnError_Handler(CPhidgetDictionaryHandle dict,
    int( *fptr)(CPhidgetDictionaryHandle, void *, int, const char *), void *userPtr);
 int CPhidgetDictionary_addKey(CPhidgetDictionaryHandle dict, const char *key, const char *val, int persistent);
 int CPhidgetDictionary_removeKey(CPhidgetDictionaryHandle dict, const char *pattern);
 int CPhidgetDictionary_set_OnKeyChange_Handler(CPhidgetDictionaryHandle dict, CPhidgetDictionaryListenerHandle *dictlistener, const char *pattern,
 int( *fptr)(CPhidgetDictionaryHandle dict, void *userPtr, const char *key, const char *val, CPhidgetDictionary_keyChangeReason reason),
 void *userPtr);
 int CPhidgetDictionary_remove_OnKeyChange_Handler(CPhidgetDictionaryListenerHandle keylistener);
 int CPhidgetDictionary_getKey(CPhidgetDictionaryHandle dict, const char *key, const char *val, int valsize);
typedef struct _CPhidgetManager __CPhidgetManager; typedef __CPhidgetManager *CPhidgetManagerHandle;
 int CPhidgetManager_create(CPhidgetManagerHandle *phidm);
 int CPhidgetManager_open(CPhidgetManagerHandle phidm);
 int CPhidgetManager_close(CPhidgetManagerHandle phidm);
 int CPhidgetManager_delete(CPhidgetManagerHandle phidm);
 int CPhidgetManager_set_OnAttach_Handler(CPhidgetManagerHandle phidm, int ( *fptr)(CPhidgetHandle phid, void *userPtr), void *);
 int CPhidgetManager_set_OnDetach_Handler(CPhidgetManagerHandle phidm, int ( *fptr)(CPhidgetHandle phid, void *userPtr), void *);
 int CPhidgetManager_getAttachedDevices(CPhidgetManagerHandle phidm, CPhidgetHandle *phidArray[], int *count);
 int CPhidgetManager_set_OnError_Handler(CPhidgetManagerHandle phidm, int( *fptr)(CPhidgetManagerHandle, void *, int, const char *), void *userPtr);
 int CPhidget_openRemote(CPhidgetHandle phid,
    int serial, const char *serverID, const char *passWord);
 int CPhidget_openRemoteIP(CPhidgetHandle phid,
    int serial, const char *addr, int port, const char *passWord);
 int CPhidgetManager_openRemoteIP(CPhidgetManagerHandle phidm,
 const char *address, int port, const char *password);
 int CPhidgetManager_openRemote(CPhidgetManagerHandle phidm,
 const char *serverID, const char *passWord);
 int CPhidgetDictionary_openRemoteIP(CPhidgetDictionaryHandle dict,
 const char *address, int port, const char *password);
 int CPhidgetDictionary_openRemote(CPhidgetDictionaryHandle dict,
 const char *serverID, const char *passWord);
typedef struct _CPhidgetAccelerometer __CPhidgetAccelerometer; typedef __CPhidgetAccelerometer *CPhidgetAccelerometerHandle;
 int CPhidgetAccelerometer_create(CPhidgetAccelerometerHandle *);
 int CPhidgetAccelerometer_getAccelerationChangeTrigger(CPhidgetAccelerometerHandle, int Index, double *pVal); int CPhidgetAccelerometer_setAccelerationChangeTrigger(CPhidgetAccelerometerHandle, int Index, double newVal);
 int CPhidgetAccelerometer_getNumAxis(CPhidgetAccelerometerHandle, int *pVal);
 int CPhidgetAccelerometer_getAcceleration(CPhidgetAccelerometerHandle, int Index, double *pVal);
 int CPhidgetAccelerometer_set_OnAccelerationChange_Handler(CPhidgetAccelerometerHandle, int ( *fptr)(CPhidgetAccelerometerHandle, void *, int, double), void *);
typedef struct _CPhidgetAdvancedServo __CPhidgetAdvancedServo; typedef __CPhidgetAdvancedServo *CPhidgetAdvancedServoHandle;
 int CPhidgetAdvancedServo_create(CPhidgetAdvancedServoHandle *);
 int CPhidgetAdvancedServo_getNumMotors(CPhidgetAdvancedServoHandle, int *pVal);
 int CPhidgetAdvancedServo_getAcceleration(CPhidgetAdvancedServoHandle, int Index, double *pVal); int CPhidgetAdvancedServo_setAcceleration(CPhidgetAdvancedServoHandle, int Index, double newVal);
 int CPhidgetAdvancedServo_getMaxVelocity(CPhidgetAdvancedServoHandle, int Index, double *pVal); int CPhidgetAdvancedServo_setMaxVelocity(CPhidgetAdvancedServoHandle, int Index, double newVal);
 int CPhidgetAdvancedServo_getMotorPosition(CPhidgetAdvancedServoHandle, int Index, double *pVal); int CPhidgetAdvancedServo_setMotorPosition(CPhidgetAdvancedServoHandle, int Index, double newVal);
 int CPhidgetAdvancedServo_getCurrent(CPhidgetAdvancedServoHandle, int Index, double *pVal);
 int CPhidgetAdvancedServo_set_OnPositionChange_Handler(CPhidgetAdvancedServoHandle, int ( *fptr)(CPhidgetAdvancedServoHandle, void *, int, double), void *);
typedef struct _CPhidgetEncoder __CPhidgetEncoder; typedef __CPhidgetEncoder *CPhidgetEncoderHandle;
 int CPhidgetEncoder_create(CPhidgetEncoderHandle *);
 int CPhidgetEncoder_getEncoderPosition(CPhidgetEncoderHandle, int Index, int *pVal); int CPhidgetEncoder_setEncoderPosition(CPhidgetEncoderHandle, int Index, int newVal);
 int CPhidgetEncoder_getNumInputs(CPhidgetEncoderHandle, int *pVal);
 int CPhidgetEncoder_getNumEncoders(CPhidgetEncoderHandle, int *pVal);
 int CPhidgetEncoder_getInputState(CPhidgetEncoderHandle, int Index, int *pVal);
 int CPhidgetEncoder_set_OnInputChange_Handler(CPhidgetEncoderHandle, int ( *fptr)(CPhidgetEncoderHandle, void *, int, int), void *);
 int CPhidgetEncoder_set_OnPositionChange_Handler(CPhidgetEncoderHandle, int ( *fptr)(CPhidgetEncoderHandle, void *, int, int, int), void *);
typedef struct _CPhidgetGPS __CPhidgetGPS; typedef __CPhidgetGPS *CPhidgetGPSHandle;
struct __GPSTime
{
 short tm_sec,tm_min,tm_hour;
} typedef GPSTime;
struct __GPSDate
{
 short tm_mday, tm_mon, tm_year;
} typedef GPSDate;
struct __GPSSatInfo
{
 short ID;
 short elevation;
 int azimuth;
 short SNR;
} typedef GPSSatInfo;
struct __GPGGA
{
 GPSTime time;
 double latitude;
 double longitude;
 short fixQuality;
 short numSatellites;
 double horizontalDilution;
 double altitude;
 double heightOfGeoid;
} typedef GPGGA;
struct __GPGSA
{
 char mode;
 short fixType;
 short satUsed[12];
 double posnDilution;
 double horizDilution;
 double vertDilution;
} typedef GPGSA;
struct __GPGSV
{
 short satsInView;
 GPSSatInfo satInfo[12];
} typedef GPGSV;
struct __GPRMC
{
 GPSTime time;
 char status;
 double latitude;
 double longitude;
 double speed;
 double heading;
 GPSDate date;
 double magneticVariation;
} typedef GPRMC;
struct __GPSInfo
{
 GPGGA GGA;
 GPGSA GSA;
 GPGSV GSV;
 GPRMC RMC;
} typedef GPSInfo;
 int CPhidgetGPS_create(CPhidgetGPSHandle *);
 int CPhidgetGPS_getLatitude(CPhidgetGPSHandle, double *pVal);
 int CPhidgetGPS_getLongitude(CPhidgetGPSHandle, double *pVal);
 int CPhidgetGPS_getAltitude(CPhidgetGPSHandle, double *pVal);
 int CPhidgetGPS_getTime(CPhidgetGPSHandle, GPSTime *pVal);
 int CPhidgetGPS_getRawData(CPhidgetGPSHandle, GPSInfo *pVal);
 int CPhidgetGPS_getPositionChangeTrigger(CPhidgetGPSHandle, double *pVal); int CPhidgetGPS_setPositionChangeTrigger(CPhidgetGPSHandle, double newVal);
 int CPhidgetGPS_set_OnPositionChange_Handler(CPhidgetGPSHandle, int ( *fptr)(CPhidgetGPSHandle, void *, double,double,double), void *);
 int CPhidgetGPS_set_OnNMEAData_Handler(CPhidgetGPSHandle, int ( *fptr)(CPhidgetGPSHandle, void *, const char *), void *);
typedef struct _CPhidgetGyroscope __CPhidgetGyroscope; typedef __CPhidgetGyroscope *CPhidgetGyroscopeHandle;
 int CPhidgetGyroscope_create(CPhidgetGyroscopeHandle *);
 int CPhidgetGyroscope_getAngularRateChangeTrigger(CPhidgetGyroscopeHandle, int Index, double *pVal); int CPhidgetGyroscope_setAngularRateChangeTrigger(CPhidgetGyroscopeHandle, int Index, double newVal);
 int CPhidgetGyroscope_getNumAxis(CPhidgetGyroscopeHandle, int *pVal);
 int CPhidgetGyroscope_getAngularRate(CPhidgetGyroscopeHandle, int Index, double *pVal);
 int CPhidgetGyroscope_set_OnAngularRateChange_Handler(CPhidgetGyroscopeHandle, int ( *fptr)(CPhidgetGyroscopeHandle, void *, int, double), void *);
typedef struct _CPhidgetInterfaceKit __CPhidgetInterfaceKit;
typedef __CPhidgetInterfaceKit *CPhidgetInterfaceKitHandle;
 int CPhidgetInterfaceKit_create(CPhidgetInterfaceKitHandle *);
 int CPhidgetInterfaceKit_getOutputState(CPhidgetInterfaceKitHandle, int Index, int *pVal);
 int CPhidgetInterfaceKit_setOutputState(CPhidgetInterfaceKitHandle, int Index, int newVal);
 int CPhidgetInterfaceKit_getSensorChangeTrigger(CPhidgetInterfaceKitHandle, int Index, int *pVal);
 int CPhidgetInterfaceKit_setSensorChangeTrigger(CPhidgetInterfaceKitHandle, int Index, int newVal);
 int CPhidgetInterfaceKit_getNumInputs(CPhidgetInterfaceKitHandle, int *pVal);
 int CPhidgetInterfaceKit_getNumOutputs(CPhidgetInterfaceKitHandle, int *pVal);
 int CPhidgetInterfaceKit_getNumSensors(CPhidgetInterfaceKitHandle, int *pVal);
 int CPhidgetInterfaceKit_getInputState(CPhidgetInterfaceKitHandle, int Index, int *pVal);
 int CPhidgetInterfaceKit_getSensorValue(CPhidgetInterfaceKitHandle, int Index, int *pVal);
 int CPhidgetInterfaceKit_getSensorRawValue(CPhidgetInterfaceKitHandle, int Index, int *pVal);
 int CPhidgetInterfaceKit_getRatiometric(CPhidgetInterfaceKitHandle, int *pVal);
 int CPhidgetInterfaceKit_setRatiometric(CPhidgetInterfaceKitHandle, int newVal);
 int CPhidgetInterfaceKit_set_OnInputChange_Handler(
    CPhidgetInterfaceKitHandle, int ( *fptr)(CPhidgetInterfaceKitHandle,
    void *, int, int), void *);
 int CPhidgetInterfaceKit_set_OnOutputChange_Handler(
    CPhidgetInterfaceKitHandle, int ( *fptr)(CPhidgetInterfaceKitHandle,
    void *, int, int), void *);
 int CPhidgetInterfaceKit_set_OnSensorChange_Handler(
    CPhidgetInterfaceKitHandle, int ( *fptr)(CPhidgetInterfaceKitHandle,
    void *, int, int), void *);
typedef struct _CPhidgetLED __CPhidgetLED; typedef __CPhidgetLED *CPhidgetLEDHandle;
 int CPhidgetLED_create(CPhidgetLEDHandle *);
 int CPhidgetLED_getNumLEDs(CPhidgetLEDHandle, int *pVal);
 int CPhidgetLED_getDiscreteLED(CPhidgetLEDHandle, int Index, int *pVal); int CPhidgetLED_setDiscreteLED(CPhidgetLEDHandle, int Index, int newVal);
typedef struct _CPhidgetMotorControl __CPhidgetMotorControl; typedef __CPhidgetMotorControl *CPhidgetMotorControlHandle;
 int CPhidgetMotorControl_create(CPhidgetMotorControlHandle *);
 int CPhidgetMotorControl_getNumInputs(CPhidgetMotorControlHandle, int *pVal);
 int CPhidgetMotorControl_getNumMotors(CPhidgetMotorControlHandle, int *pVal);
 int CPhidgetMotorControl_getInputState(CPhidgetMotorControlHandle, int Index, int *pVal);
 int CPhidgetMotorControl_getAcceleration(CPhidgetMotorControlHandle, int Index, double *pVal); int CPhidgetMotorControl_setAcceleration(CPhidgetMotorControlHandle, int Index, double newVal);
 int CPhidgetMotorControl_getMotorSpeed(CPhidgetMotorControlHandle, int Index, double *pVal); int CPhidgetMotorControl_setMotorSpeed(CPhidgetMotorControlHandle, int Index, double newVal);
 int CPhidgetMotorControl_set_OnInputChange_Handler(CPhidgetMotorControlHandle, int ( *fptr)(CPhidgetMotorControlHandle, void *, int, int), void *);
 int CPhidgetMotorControl_set_OnMotorChange_Handler(CPhidgetMotorControlHandle, int ( *fptr)(CPhidgetMotorControlHandle, void *, int, double), void *);
 int CPhidgetMotorControl_set_OnCurrentChange_Handler(CPhidgetMotorControlHandle, int ( *fptr)(CPhidgetMotorControlHandle, void *, int, double), void *);
typedef struct _CPhidgetPHSensor __CPhidgetPHSensor; typedef __CPhidgetPHSensor *CPhidgetPHSensorHandle;
 int CPhidgetPHSensor_create(CPhidgetPHSensorHandle *);
 int CPhidgetPHSensor_getPH(CPhidgetPHSensorHandle, double *pVal);
 int CPhidgetPHSensor_getPotential(CPhidgetPHSensorHandle, double *pVal);
 int CPhidgetPHSensor_getPHChangeTrigger(CPhidgetPHSensorHandle, double *pVal); int CPhidgetPHSensor_setPHChangeTrigger(CPhidgetPHSensorHandle, double newVal);
 int CPhidgetPHSensor_set_OnPHChange_Handler(CPhidgetPHSensorHandle, int ( *fptr)(CPhidgetPHSensorHandle, void *, double), void *);
typedef struct _CPhidgetRFID __CPhidgetRFID; typedef __CPhidgetRFID *CPhidgetRFIDHandle;
 int CPhidgetRFID_create(CPhidgetRFIDHandle *);
 int CPhidgetRFID_getNumOutputs(CPhidgetRFIDHandle, int *pVal);
 int CPhidgetRFID_getOutputState(CPhidgetRFIDHandle, int Index, int *pVal); int CPhidgetRFID_setOutputState(CPhidgetRFIDHandle, int Index, int newVal);
 int CPhidgetRFID_getAntennaOn(CPhidgetRFIDHandle, int *pVal); int CPhidgetRFID_setAntennaOn(CPhidgetRFIDHandle, int newVal);
 int CPhidgetRFID_getLEDOn(CPhidgetRFIDHandle, int *pVal); int CPhidgetRFID_setLEDOn(CPhidgetRFIDHandle, int newVal);
 int CPhidgetRFID_set_OnOutputChange_Handler(CPhidgetRFIDHandle, int ( *fptr)(CPhidgetRFIDHandle, void *, int, int), void *);
 int CPhidgetRFID_getLastTag(CPhidgetRFIDHandle, unsigned char *pVal);
 int CPhidgetRFID_set_OnTag_Handler(CPhidgetRFIDHandle, int ( *fptr)(CPhidgetRFIDHandle, void *, unsigned char *), void *);
 int CPhidgetRFID_set_OnTagLost_Handler(CPhidgetRFIDHandle, int ( *fptr)(CPhidgetRFIDHandle, void *, unsigned char *), void *);
typedef struct _CPhidgetServo __CPhidgetServo; typedef __CPhidgetServo *CPhidgetServoHandle;
 int CPhidgetServo_create(CPhidgetServoHandle *);
 int CPhidgetServo_getNumMotors(CPhidgetServoHandle, int *pVal);
 int CPhidgetServo_getMotorPosition(CPhidgetServoHandle, int Index, double *pVal); int CPhidgetServo_setMotorPosition(CPhidgetServoHandle, int Index, double newVal);
 int CPhidgetServo_set_OnMotorPositionChange_Handler(CPhidgetServoHandle, int ( *fptr)(CPhidgetServoHandle, void *, int, double), void *);
typedef struct _CPhidgetStepper __CPhidgetStepper; typedef __CPhidgetStepper *CPhidgetStepperHandle;
 int CPhidgetStepper_create(CPhidgetStepperHandle *);
 int CPhidgetStepper_getNumInputs(CPhidgetStepperHandle, int *pVal);
 int CPhidgetStepper_getNumMotors(CPhidgetStepperHandle, int *pVal);
 int CPhidgetStepper_getInputState(CPhidgetStepperHandle, int Index, int *pVal);
 int CPhidgetStepper_getAcceleration(CPhidgetStepperHandle, int Index, double *pVal); int CPhidgetStepper_setAcceleration(CPhidgetStepperHandle, int Index, double newVal);
 int CPhidgetStepper_getMotorSpeed(CPhidgetStepperHandle, int Index, double *pVal); int CPhidgetStepper_setMotorSpeed(CPhidgetStepperHandle, int Index, double newVal);
 int CPhidgetStepper_getMotorPosition(CPhidgetStepperHandle, int Index, long long *pVal); int CPhidgetStepper_setMotorPosition(CPhidgetStepperHandle, int Index, long long newVal);
 int CPhidgetStepper_set_OnInputChange_Handler(CPhidgetStepperHandle, int ( *fptr)(CPhidgetStepperHandle, void *, int, int), void *);
 int CPhidgetStepper_set_OnPositionChange_Handler(CPhidgetStepperHandle, int ( *fptr)(CPhidgetStepperHandle, void *, int, long long), void *);
 int CPhidgetStepper_set_OnSpeedChange_Handler(CPhidgetStepperHandle, int ( *fptr)(CPhidgetStepperHandle, void *, int, double), void *);
typedef struct _CPhidgetTemperatureSensor __CPhidgetTemperatureSensor; typedef __CPhidgetTemperatureSensor *CPhidgetTemperatureSensorHandle;
 int CPhidgetTemperatureSensor_create(CPhidgetTemperatureSensorHandle *);
 int CPhidgetTemperatureSensor_getNumTemperatureInputs(CPhidgetTemperatureSensorHandle, int *pVal);
 int CPhidgetTemperatureSensor_getTemperature(CPhidgetTemperatureSensorHandle, int Index, double *pVal);
 int CPhidgetTemperatureSensor_getTemperatureChangeTrigger(CPhidgetTemperatureSensorHandle, int Index, double *pVal); int CPhidgetTemperatureSensor_setTemperatureChangeTrigger(CPhidgetTemperatureSensorHandle, int Index, double newVal);
 int CPhidgetTemperatureSensor_set_OnTemperatureChange_Handler(CPhidgetTemperatureSensorHandle, int ( *fptr)(CPhidgetTemperatureSensorHandle, void *, int, double), void *);
typedef struct _CPhidgetTextLCD __CPhidgetTextLCD; typedef __CPhidgetTextLCD *CPhidgetTextLCDHandle;
 int CPhidgetTextLCD_create(CPhidgetTextLCDHandle *);
 int CPhidgetTextLCD_getNumRows(CPhidgetTextLCDHandle, int *pVal);
 int CPhidgetTextLCD_getNumColumns(CPhidgetTextLCDHandle, int *pVal);
 int CPhidgetTextLCD_getBacklight(CPhidgetTextLCDHandle, int *pVal); int CPhidgetTextLCD_setBacklight(CPhidgetTextLCDHandle, int newVal);
 int CPhidgetTextLCD_getContrast(CPhidgetTextLCDHandle, int *pVal); int CPhidgetTextLCD_setContrast(CPhidgetTextLCDHandle, int newVal);
 int CPhidgetTextLCD_getCursorOn(CPhidgetTextLCDHandle, int *pVal); int CPhidgetTextLCD_setCursorOn(CPhidgetTextLCDHandle, int newVal);
 int CPhidgetTextLCD_getCursorBlink(CPhidgetTextLCDHandle, int *pVal); int CPhidgetTextLCD_setCursorBlink(CPhidgetTextLCDHandle, int newVal);
 int CPhidgetTextLCD_setCustomCharacter (CPhidgetTextLCDHandle, int Index, int Val1, int Val2);
 int CPhidgetTextLCD_setDisplayString(CPhidgetTextLCDHandle, int Row, char *displayString);
typedef struct _CPhidgetTextLED __CPhidgetTextLED; typedef __CPhidgetTextLED *CPhidgetTextLEDHandle;
 int CPhidgetTextLED_create(CPhidgetTextLEDHandle *);
 int CPhidgetTextLED_getNumRows(CPhidgetTextLEDHandle, int *pVal);
 int CPhidgetTextLED_getNumColumns(CPhidgetTextLEDHandle, int *pVal);
 int CPhidgetTextLED_getBrightness(CPhidgetTextLEDHandle, int *pVal); int CPhidgetTextLED_setBrightness(CPhidgetTextLEDHandle, int newVal);
 int CPhidgetTextLED_setDisplayString(CPhidgetTextLEDHandle, int Row, char *displayString);
typedef struct _CPhidgetWeightSensor __CPhidgetWeightSensor; typedef __CPhidgetWeightSensor *CPhidgetWeightSensorHandle;
 int CPhidgetWeightSensor_create(CPhidgetWeightSensorHandle *);
 int CPhidgetWeightSensor_getWeight(CPhidgetWeightSensorHandle, double *pVal);
 int CPhidgetWeightSensor_getWeightChangeTrigger(CPhidgetWeightSensorHandle, double *pVal); int CPhidgetWeightSensor_setWeightChangeTrigger(CPhidgetWeightSensorHandle, double newVal);
 int CPhidgetWeightSensor_set_OnWeightChange_Handler(CPhidgetWeightSensorHandle, int ( *fptr)(CPhidgetWeightSensorHandle, void *, double), void *);
#ifdef __cplusplus
}
#endif
#endif
