#ifndef __WINCOMPAT_H
#define __WINCOMPAT_H

#ifdef _MSC_EXTENSIONS
#include "snprintf.h"
#include "regex/regex.h"
#endif

#ifndef EXTERNALPROTO

typedef struct pthread *pthread_t;
typedef struct pthread_attr pthread_attr_t;
typedef struct pthread_cond *pthread_cond_t;
typedef struct pthread_condattr pthread_condattr_t;
typedef struct pthread_mutex *pthread_mutex_t;
typedef struct pthread_mutexattr pthread_mutexattr_t;

extern int pthread_create(pthread_t *, const pthread_attr_t *,
    void * (*)(void *), void *);
extern int pthread_join(pthread_t, void **);
extern int pthread_mutex_init(pthread_mutex_t *, const pthread_mutexattr_t *);
extern int pthread_mutex_destroy(pthread_mutex_t *);
extern int pthread_mutex_lock(pthread_mutex_t *);
extern int pthread_mutex_unlock(pthread_mutex_t *);
extern int pthread_cond_destroy(pthread_cond_t *);
extern int pthread_cond_init(pthread_cond_t *, const pthread_condattr_t *);
extern int pthread_cond_wait(pthread_cond_t *, pthread_mutex_t *);
extern int pthread_cond_signal(pthread_cond_t *);
extern pthread_t pthread_self(void);

int usleep(unsigned long useconds);

void wsa_set_errdesc(char *errdesc, int errlen);

#if (defined(_WINDOWS) && defined(__GNUC__)) || defined(WINCE)
char *strdup(const char *);
#endif

#endif
#endif
